package formen;

import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.PixelWriter;
import javafx.scene.paint.Color;
import javafx.scene.transform.Affine;
import javafx.stage.Stage;

public class Ebene extends Application {

    PixelWriter pixelWriter;

    private final int hoehe = 768;
    private final int breite = 1024;
    private final int rand = 0;

    // Drawing Surface (Canvas)
    private GraphicsContext gc;
    private Canvas canvas;
    private Group root;

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) {
        primaryStage.setTitle("Einige 2D-Objekte");
        root = new Group();
        canvas = new Canvas(breite - rand, hoehe - rand);
        gc = canvas.getGraphicsContext2D();
        gc.setTransform(this.affineAbbildung(breite, hoehe));

        root.getChildren().add(canvas);

        this.zeichneElemente(gc);

        primaryStage.setScene(new Scene(root, breite, hoehe));
        primaryStage.show();

    }

    private void zeichneElemente(GraphicsContext gc) {
        Dreieck meinDreieck = new Dreieck(
                new Punkt(0, 0),
                new Punkt(0, 100),
                new Punkt(100, 0)
        );
        
        meinDreieck.zeichnen(gc);
        meinDreieck.setFarbe(Color.BLUE);
        meinDreieck.setA(new Punkt(-50,-50));
        meinDreieck.zeichnen(gc);
        
    }

    Affine affineAbbildung(int breite, int hoehe) {
        Affine affine = new Affine();
        affine.appendTranslation(breite / 2, hoehe / 2);
        affine.appendScale(1.0, -1.0);
        return affine;
    }

}
